import React from 'react';
import { SWRConfig } from 'swr';
import { AsyncConfigContext } from './useRequest/context';
import { axiosService } from './axios';
const AsyncRequestProvider = (props) => {
    const { value, children } = props;
    const { axiosInstance } = value;
    axiosService.setAixosInstance(axiosInstance);
    const swrConfig = Object.assign(Object.assign({}, value), { fetcher: (params) => axiosInstance(params) });
    return (React.createElement(AsyncConfigContext.Provider, { value: swrConfig },
        React.createElement(SWRConfig, { value: swrConfig }, children)));
};
export default AsyncRequestProvider;
//# sourceMappingURL=AsyncRequestProvider.js.map