var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { httpAxios } from './httpAxios';
describe('httpAxios', () => {
    // 测试钩子是否被调用
    it('inject httpAxios hooks', () => __awaiter(void 0, void 0, void 0, function* () {
        const mockCallback = jest.fn();
        const injectHooksAxios = httpAxios({}, {
            requestSuccessHook(config) {
                mockCallback();
                return config;
            },
            requestErrorHooks(config) {
                mockCallback();
                return config;
            },
        });
        const request = injectHooksAxios.interceptors.request;
        request.handlers[0].fulfilled({
            method: 'get'
        });
        request.handlers[0].rejected({});
        expect(mockCallback.mock.calls.length).toBe(2);
    }));
});
//# sourceMappingURL=httpAxios.test.js.map