import React from 'react';
import { SWRConfig } from 'swr';
import { axiosService } from './axios';
import { AsyncConfigContext } from './useRequest/context';
const request_middleware = (requestConfigs) => {
    const { axiosInstance } = requestConfigs;
    axiosService.setAixosInstance(axiosInstance);
    const swrConfig = Object.assign(Object.assign({}, requestConfigs), { fetcher: (params) => axiosInstance(params) });
    return ({ App, configuration }) => {
        return {
            App(props) {
                return (React.createElement(AsyncConfigContext.Provider, { value: swrConfig },
                    React.createElement(SWRConfig, { value: swrConfig },
                        React.createElement(App, Object.assign({}, props)))));
            },
            configuration
        };
    };
};
export default request_middleware;
//# sourceMappingURL=request.middleware.js.map