import React from 'react';
import invariant from 'invariant';
import useAsync from './useAsync';
function useManalRequest(service, config) {
    const pausedRef = React.useRef(true);
    const rerender = React.useState(null)[1];
    const paramsRef = React.useRef({});
    // Dynamically change the key according to the timing of run
    const dynamicParams = React.useRef({ _: new Date().getTime() });
    const nextService = React.useMemo(() => {
        // service is HeadService, will be return LastService
        return service(paramsRef.current, { _: dynamicParams.current });
    }, [
        dynamicParams,
        paramsRef.current
    ]);
    const pauper = React.useCallback(() => {
        pausedRef.current = true;
    }, []);
    if (config.isPaused) {
        invariant(false, 'manual model cannot be set isPaused');
    }
    const nextConfig = Object.assign(Object.assign({}, config), { onSuccess: (...res) => {
            pauper();
            config.onSuccess && config.onSuccess(...res);
        }, onError: (...res) => {
            pauper();
            config.onError && config.onError(...res);
        }, isPaused() {
            return pausedRef.current;
        } });
    const response = useAsync(nextService, nextConfig);
    const run = (params) => {
        pausedRef.current = false;
        paramsRef.current = params;
        dynamicParams.current = new Date().getTime();
        rerender({});
    };
    return Object.assign(Object.assign({}, response), { run });
}
export default useManalRequest;
//# sourceMappingURL=useManalAsync.js.map