var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import useAsync from './useAsync';
import { genarateServiceConfig, mergeServiceParams, contrastServiceParams } from './utils';
const PAGINATION_LIST = ['10', '20', '50', '100', '200', '500'];
function usePagination(service, config) {
    const { defaultPageSize = 10 } = config;
    const rerender = React.useState(null)[1];
    const paginationRef = React.useRef({
        page: 1,
        pageSize: defaultPageSize,
    });
    // xn
    const serviceRef = React.useRef(service);
    // 对比前后service参数是否相同
    const isEqualParmas = contrastServiceParams(serviceRef.current, service);
    serviceRef.current = service;
    // 参数改变，页数要重置
    if (!isEqualParmas) {
        paginationRef.current.page = 1;
    }
    // get service object
    const serviceConfig = genarateServiceConfig(serviceRef.current);
    // merger pagination to service params
    const nextServiceConfig = mergeServiceParams(serviceConfig, paginationRef.current);
    const _a = useAsync(nextServiceConfig, config), { responseArray } = _a, response = __rest(_a, ["responseArray"]);
    const onLoadMore = () => {
        if (!service || !response.params)
            return;
        paginationRef.current.page++;
        rerender({});
    };
    const { tableProps, pagination } = React.useMemo(() => {
        const pagination = {
            current: paginationRef.current.page,
            pageSizeOptions: PAGINATION_LIST,
            showSizeChanger: true,
            pageSize: paginationRef.current.pageSize,
            onChange: (page) => {
                paginationRef.current.page = page;
                rerender({});
            },
            total: responseArray.total || 0,
            onShowSizeChange(current, pageSize) {
                paginationRef.current.pageSize = pageSize;
            }
        };
        return {
            pagination,
            tableProps: {
                pagination,
                loading: response.isValidating,
                dataSource: response.dataArray
            }
        };
    }, [
        responseArray.total,
        paginationRef.current,
        rerender,
        response.isValidating,
        response.dataArray
    ]);
    return Object.assign({ tableProps,
        onLoadMore,
        pagination,
        responseArray }, response);
}
export default usePagination;
//# sourceMappingURL=usePagination.js.map